#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>
#include <math.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "common.h" 




void
on_open1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	GtkWidget *dialog = create_filechooserdialog1 () ;
	uint8_t *data;
	beat_scene scene;
	int length, i ;
	
	if (gtk_dialog_run (GTK_DIALOG (dialog)) == GTK_RESPONSE_OK) {
    	char *filename;

    	filename = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (dialog));
    	load_from_file(filename);
		
		for(i=0; i< get_slow_scene_count() ; i++ ){
			data = get_from_slow(i, &length) ;
			add_slow_scene_to_table((GtkWidget*) menuitem , data, length)  ;
		}
	
		for(i=0; i< get_beat_scene_count() ; i++ ){
			get_from_beat(i, &scene) ;
			add_beat_scene_to_table((GtkWidget*) menuitem, &scene) ;
		}		
		
    	g_free (filename);
	}

	gtk_widget_destroy (dialog);
}


void
on_save1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	GtkWidget *dialog = create_filechooserdialog2 () ;
	
	if (gtk_dialog_run (GTK_DIALOG (dialog)) == GTK_RESPONSE_OK) {
		
    	char *filename;

    	filename = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (dialog));
    	save_to_file(filename);
    	g_free (filename);
	}

	gtk_widget_destroy (dialog);
}


void
on_save_as1_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_quit1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}







void
on_about1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

	
	
}


void
on_all_full1_activate                  (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	all_on((GtkWidget*) menuitem) ;
}




gboolean
on_window_delete_event                 (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
	gtk_main_quit (); 
	return FALSE;
}

void
scan_button_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
		artnet_send_poll(node, NULL, ARTNET_TTM_DEFAULT) ;
}

void
on_combobox1_changed                   (GtkComboBox     *combobox,
                                        gpointer         user_data)
{
//	int  i = gtk_combo_box_get_active(combobox) ;
}

void
scenes_changed                         (GtkRange        *range,
                                        gpointer         user_data)
{

}

void
on_flash_button1_pressed               (GtkButton       *button,
                                        gpointer         user_data)
{
	uint8_t data[12] ;
	int ret,i ;
	
	ret = get_slider_values((GtkWidget*) button, data, 12) ;
		
	for(i=0;  i <12; i++) {
		printf("%i ", data[i] ) ;
	}
	printf("\n") ;
}


void
on_flash_button1_released              (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
on_fader_vscale_value_changed          (GtkRange        *range,
                                        gpointer         user_data)
{
	gchar *gstr ;
	GtkVScale *scale ;
	GtkLabel *label ;
	gdouble val ;
	
	scale = (GtkVScale*) lookup_widget((GtkWidget*) range, "fader_vscale") ;
	label = (GtkLabel*) lookup_widget((GtkWidget*) range, "fader_label") ;
	val = gtk_range_get_value((GtkRange*) scale) ;
	val = pow(2,val)-1  ;

	if(val >= 60) {
		gstr = g_strdup_printf("%.1f m", val/60) ;
	} else {
		gstr = g_strdup_printf("%.1f s", val) ;
	}
	gtk_label_set_text(label, gstr) ;
	fade_time = val*1000 ;
	
	if(fade_status == IN_FADE) 
		fade_status = FADE_CHANGE ;
	
}


void slider_changed(GtkRange *range, int id) {
	int master, val ;
	GtkVScale *scale ;

	scale = (GtkVScale*) lookup_widget((GtkWidget*) range, "master_vscale") ;
	master = gtk_range_get_value((GtkRange*) scale) ;
	
	val = gtk_range_get_value( range) ;
	data_sliders[id] = (val * master) / 255 ;
	//printf("val now is %d\n", data_sliders[id] ) ;

	if(fade_time != 0) 
			fade_status = FADE_START;
	
	
	
}

void
on_vscale1_value_changed               (GtkRange        *range,
                                        gpointer         user_data)
{
	slider_changed(range, 0) ;

}


void
on_port_radiobutton1_group_changed     (GtkRadioButton  *radiobutton,
                                        gpointer         user_data)
{
	int i ;
	gchar *gstr ;
	GtkRadioButton *rbut;
	active_port = 0;
	
	for(i=0; i< ARTNET_MAX_PORTS; i++) {
		gstr = g_strdup_printf("port_radiobutton%i", i+1) ;
		rbut = (GtkRadioButton *) lookup_widget((GtkWidget*) radiobutton, gstr) ;
		if( gtk_toggle_button_get_active((GtkToggleButton*) rbut))
			active_port = i ;
	}
}

void
on_vscale2_value_changed               (GtkRange        *range,
                                        gpointer         user_data)
{
	slider_changed(range, 1) ;
}


void
on_vscale3_value_changed               (GtkRange        *range,
                                        gpointer         user_data)
{
	slider_changed(range, 2) ;
}


void
on_vscale4_value_changed               (GtkRange        *range,
                                        gpointer         user_data)
{
	slider_changed(range, 3) ;
}


void
on_master_vscale_value_changed         (GtkRange        *range,
                                        gpointer         user_data)
{

	int i, master, val ;
	gchar *gstr ;
	GtkVScale *scale ;

	scale = (GtkVScale*) lookup_widget((GtkWidget*) range, "master_vscale") ;
	master = gtk_range_get_value((GtkRange*) scale) ;
	
	for(i=0; i< 12; i++) {
		gstr = g_strdup_printf("vscale%i", i+1) ;
		scale = (GtkVScale *) lookup_widget((GtkWidget *) range, gstr) ;
		val = gtk_range_get_value((GtkRange*) scale) ;
		data_sliders[i] = (val * master) / 255 ;
	//	printf("val %d is 0x%02hhx\n", i, data_sliders[i] ) ;
	}
	
}

void
on_vscale5_value_changed               (GtkRange        *range,
                                        gpointer         user_data)
{
slider_changed(range, 4) ;
}


void
on_vscale6_value_changed               (GtkRange        *range,
                                        gpointer         user_data)
{
slider_changed(range, 5) ;
}


void
on_vscale7_value_changed               (GtkRange        *range,
                                        gpointer         user_data)
{
slider_changed(range, 6) ;
}


void
on_vscale8_value_changed               (GtkRange        *range,
                                        gpointer         user_data)
{
slider_changed(range, 7) ;
}

void
on_view1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}



void
on_audio_window1_toggled               (GtkCheckMenuItem *checkmenuitem,
                                        gpointer         user_data)
{
	GtkWidget *audioWindow = (GtkWidget*) user_data ;

	if( GTK_WIDGET_VISIBLE(audioWindow) ) {
		gtk_widget_hide(audioWindow) ;
	} else {
		gtk_widget_show(audioWindow) ;
		
	}
}

/*
 * Called when the audio window is closed
 */
gboolean on_audio_window_delete(GtkWindow *window,  GdkEvent *event, gpointer user_data) {	
	GtkWidget *top = (GtkWidget*) user_data ;
	GtkCheckMenuItem *menu = (GtkCheckMenuItem*) lookup_widget(top, "audio_window1") ;

	gtk_check_menu_item_set_active(menu, FALSE) ;
	
	gtk_widget_hide((GtkWidget*) window) ;
	
	
	return TRUE;
}

void
on_vscale9_value_changed               (GtkRange        *range,
                                        gpointer         user_data)
{
	slider_changed(range, 8) ;
}


void
on_vscale10_value_changed              (GtkRange        *range,
                                        gpointer         user_data)
{
	slider_changed(range, 9) ;
}


void
on_vscale11_value_changed              (GtkRange        *range,
                                        gpointer         user_data)
{
	slider_changed(range, 10) ;
}


void
on_vscale12_value_changed              (GtkRange        *range,
                                        gpointer         user_data)
{
	slider_changed(range, 11) ;
}



void
on_copy1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	uint8_t data[ARTNET_DMX_LENGTH] ;
	int len = get_slider_values((GtkWidget*)menuitem, data, ARTNET_DMX_LENGTH) ;
	copy_to_clipboard(data,len) ;
}

void
on_paste1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	uint8_t *data;
	int len ;
	data = get_from_clipboard(&len) ;
	set_slider_values((GtkWidget*) menuitem, data, len) ;
}

void
on_blackout1_activate                  (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	blackout((GtkWidget*) menuitem) ;
}



void
on_notebook1_change_current_page       (GtkNotebook     *notebook,
                                        GtkNotebookPage *page,
                                        guint            page_num,
                                        gpointer         user_data)
{
	GtkWidget *window = lookup_widget((GtkWidget*) notebook, "window1") ;
	
	if(page_num == 0) {
	  // set audio callback
  		audio_window_set_callback(NULL, NULL ) ;
		
		// set timeout again
		g_timeout_add(1000/ TICKS_PER_SECOND, timeout, (gpointer) window) ;
	} else {
		audio_window_set_callback(audio_callback, window) ;
	}
	
}

void
on_save_slow1_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

	uint8_t data[ARTNET_DMX_LENGTH] ;
	int len = get_slider_values((GtkWidget*) menuitem, data, ARTNET_DMX_LENGTH) ;
	
	if (copy_to_slow(data,len) == -1) {
		printf("slow memory is full") ;
	} else {
		add_slow_scene_to_table((GtkWidget*) menuitem , data, len)  ;
	}
    
}

gboolean flash_button ( GtkWidget *widget, GdkEvent *event, int id) {
	uint8_t data[ARTNET_DMX_LENGTH] ;
	int len ;
	
	if(event->type == GDK_BUTTON_PRESS) {
		printf ("button pressed\n") ;
		
		if(event->button.state & GDK_CONTROL_MASK) {
			printf("control was down\n") ;
			len = get_slider_values(widget, data, ARTNET_DMX_LENGTH) ;
			
			if (store_flash(0,data,len) == -1) 
				printf("flash memory is full") ;
			
		} else {
			flashes_on[0] = 1 ;	
		}
	} else if ( event->type == GDK_BUTTON_RELEASE) {
		printf("button release\n") ;	
		flashes_on[0] = 0 ;
		
		
	}
  return FALSE;
}
	
	
gboolean
on_togglebutton1_event                 (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
	return flash_button(widget, event, 0) ;
}

void
on_beat_mode_button_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkWidget *window = (GtkWidget*) user_data ;
	GtkEntry *entry = (GtkEntry*) lookup_widget((GtkWidget*) window, "scene_name_entry") ;
	GtkComboBox *combo ;
	GtkSpinButton *but1, *but2 ;
	beat_scene scene ;
	int i ;
	gchar *gstr ;	
	
	memset(&scene, 0x00, sizeof(beat_scene) ) ;
	
	show_beat_window(window, scene) ;
	
	for(i=0; i<SLIDERS; i++) {
	
		gstr = g_strdup_printf("comboboxentry%i", i+1) ;
		combo = (GtkComboBox*) lookup_widget(window, gstr) ;
		
		gstr = g_strdup_printf("spinbutton%i", (i+1)*2) ;
		but1 = (GtkSpinButton*) lookup_widget(window, gstr) ;
		
		gstr = g_strdup_printf("spinbutton%i", (i+1)*2 + 1) ;
		but2 = (GtkSpinButton*) lookup_widget(window, gstr) ;
		
		//gtk_combo_box_set_active(combo, scene.defn[i].mode ) ;
		gtk_combo_box_set_active(combo, 1 ) ;
		gtk_spin_button_set_value( but1,  scene.defn[i].param1) ;
		gtk_spin_button_set_value( but2,  scene.defn[i].param2) ;
	}
	
	gtk_entry_set_text(entry, "") ;
		
}



void
on_cancel_button_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkWidget *window = lookup_widget((GtkWidget*) button, "beat_mode_window") ;
	
	gtk_widget_hide(window);
}


void
on_ok_button_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkWidget *window = lookup_widget((GtkWidget*) button, "beat_mode_window") ;
	GtkWidget *main_window = (GtkWidget*) user_data ;
	GtkWidget *dialog ;
	
	GtkEntry *entry = (GtkEntry*) lookup_widget((GtkWidget*) button, "scene_name_entry") ;
	GtkComboBox *combo ;
	GtkSpinButton *but1, *but2 ;

	int i, val1, val2 , error =0 ;
	gchar *gstr ;
	beat_scene scene ;
	int active ;
	
	if(strncmp("", (const char*) gtk_entry_get_text(entry), 20) == 0) {
		error = 1;

	} else {
		strncpy(scene.name, (const char*) gtk_entry_get_text(entry), 20) ;
	}
	
	for(i=0; i<SLIDERS; i++) {
		gstr = g_strdup_printf("comboboxentry%i", i+1) ;
		combo = (GtkComboBox*) lookup_widget(window, gstr) ;
		
		gstr = g_strdup_printf("spinbutton%i", (i+1)*2) ;
		but1 = (GtkSpinButton*) lookup_widget(window, gstr) ;
		
		gstr = g_strdup_printf("spinbutton%i", (i+1)*2 + 1) ;
		but2 = (GtkSpinButton*) lookup_widget(window, gstr) ;
		
		active = gtk_combo_box_get_active(combo) ;
		
		if(active ==0) {
			scene.defn[i].mode = RAND ;
			
			val1 = gtk_spin_button_get_value_as_int(but1) ;
			val2 = gtk_spin_button_get_value_as_int(but2) ;
			
			if( val2 - val1 <= 0) {
				error = 1;
				break ;
			} else {
				scene.defn[i].param1 = val1 ;
				scene.defn[i].param2 = val2;
			}
		} else if(active ==1 ) {
			scene.defn[i].mode = FIXED ;
			scene.defn[i].param1 = gtk_spin_button_get_value_as_int(but1) ;
			scene.defn[i].param2 = gtk_spin_button_get_value_as_int(but2);
		} else if(active ==2 ) {
			scene.defn[i].mode = CLONE ;
			
			val1 = gtk_spin_button_get_value_as_int(but1) ;
			
			if(val1 > SLIDERS) {
				error = 1 ;
				break ;
			} else {
				scene.defn[i].param1 = val1 ;
			}

			// ignore val 2 for a clone			
			scene.defn[i].param2 = 0 ;

		} else if(active ==3 ) {
			scene.defn[i].mode = INVERSE ;
			val1 = gtk_spin_button_get_value_as_int(but1) ;
			
			if(val1 > SLIDERS) {
				error = 1 ;
			} else {
				scene.defn[i].param1 = val1 ;
			}
			
			// ignore val2 for a inverse
			scene.defn[i].param2 = 0;	

		}
	}

	if(error) {
		dialog = create_error_dialog() ;
		
		gtk_dialog_run((GtkDialog*) dialog) ;
		printf("error!!\n") ;
		return ;
	} 


	copy_to_beat(&scene) ;
	add_beat_scene_to_table(main_window, &scene)	 ;
	gtk_widget_hide(window);
}

gboolean
on_togglebutton2_event                 (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
	return flash_button(widget, event, 1) ;
}


gboolean
on_togglebutton3_event                 (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
	return flash_button(widget, event, 2) ;

}
