/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 

#define SLIDERS 12
#define SCENES 12
#define FLASHES 10

#define MAX_SLOW_SCENES 15
#define MAX_BEAT_SCENES 15

typedef enum {
	RAND,
	FIXED,
	CLONE,
	INVERSE	
} channel_mode_e ;


typedef struct {
	channel_mode_e mode;
	int param1;
	int param2;
} channel_def ;

typedef struct {
	char name[20] ;
	channel_def defn[SLIDERS];
} beat_scene;


void init_memory() ;

extern int copy_to_clipboard(uint8_t *data, int length) ;
extern uint8_t *get_from_clipboard(int *length) ;

extern int copy_to_slow(uint8_t *data, int length) ;
extern uint8_t *get_from_slow(int id, int *length) ;
extern int get_slow_scene_count() ;

extern int store_flash(int id, uint8_t *data, int length) ;
extern int store_scene(int id, uint8_t *data, int length) ;

extern uint8_t *get_flash(int id, int *length) ;
extern uint8_t *get_scene(int id, int *length) ;

extern int load_from_file(const char *file) ;
extern int save_to_file(const char *file) ;

extern int copy_to_beat(beat_scene *scene) ;
extern int get_beat_scene_count() ;
extern int get_from_beat(int id, beat_scene *tmp ) ;
